/*Однофазный частотный преобразователь автор AMatroskin,  2019 год
При написании прошивки использованы материалы с сайта AlexGyver, за что ему огромное спасибо!
https://alexgyver.ru */


#include "TM1637.h"
#include <EEPROM.h>
#include <GyverPWM.h>     //Библиотека ШИМ 
#include "GyverEncoder.h" //Библиотека энкодера 
#define CLKLED 5          //пины дисплея TM1637       
#define DIO 7             //пины дисплея TM1637 
#define CLK 2             //пины энкодера
#define DT 3              //пины энкодера
#define SW 4              //пины энкодера
#define TYPE1 0           //тип энкодера
TM1637 tm1637(CLKLED, DIO);
Encoder enc1(CLK, DT, SW, 1);
byte i = 0;                                                          //Счетчик цикла одного периода
boolean flag;                                                        //Флаг полупериодов (положит./отрицат.)
unsigned int skvazh1 = 0, skvazh2 = 0;                               //Скважность на 9 пине (положительные полупериоды), Скважность на 10 пине (отрицательные полупериоды)
int freq, Potentiometr = EEPROM.read(0), PotMapFreq, PotMapSkvaz;    //переменная для рассчета частоты, Значения положения энкодера, Значения положения энкодера (сконвертировано для регулировки частоты),
                                                                     //Значения положения энкодера (сконвертировано для регулировки амплитуды (скважности))
unsigned long int timeMillis, timePreview,                           //переменные для подсчета интервала задержки
         timeMillis2, timePreview2;
int sinus [] = {0,  126, 188, 251, 313, 375, 436, 497, 558, 618,                     // массив синусоиды
                677, 736, 794, 851, 908, 963, 1018,  1071,  1124,  1175,
                1225,  1274,  1322,  1369,  1414,  1457,  1500,  1540,  1580,  1617,
                1654,  1688,  1721,  1752,  1782,  1809,  1835,  1859,  1881,  1902,
                1920,  1937,  1952,  1964,  1975,  1984,  1991,  1996,  1999,  2000,
                1999,  1996,  1991,  1984,  1976,  1965,  1952,  1938,  1921,  1903,
                1882,  1860,  1836,  1811,  1783,  1754,  1723,  1690,  1655,  1619,
                1582,  1542,  1502,  1460,  1416,  1371,  1324,  1277,  1228,  1178,
                1126,  1074,  1020, 966, 910, 854, 797, 739, 680, 621,
                561, 500, 439, 378, 316, 254, 191, 129, 0, 0
               };
void setup() {
  tm1637.init();
  tm1637.set(BRIGHT_TYPICAL);
  pinMode(9, OUTPUT);     //Выход шим сигнала 1
  pinMode(10, OUTPUT);    //Выход шим сигнала 2
  PWM_resolution(9, 11, FAST_PWM);
  PWM_resolution(10, 11, FAST_PWM);
  attachInterrupt(0, isrCLK, CHANGE);    // прерывание на 2 пине! CLK у энка
  attachInterrupt(1, isrDT, CHANGE);     // прерывание на 3 пине! DT у энка
    freq = map(Potentiometr, 0, 254, 50, 23);
    tm1637.point(1);       //включить точки
    tm1637.display(freq);  //вывести частоту
    tm1637.display(1, 15); //буква "F" (frequency)
}
void isrCLK() {
  enc1.tick();  // отработка в прерывании
}
void isrDT() {
  enc1.tick();  // отработка в прерывании
}
void loop() {
  enc1.tick();
  if (enc1.isRight()) {
    Potentiometr = Potentiometr + 2;         // если был поворот
    Potentiometr = constrain(Potentiometr, 0, 254);
    EEPROM.write(0, Potentiometr);
    freq = map(Potentiometr, 0, 254, 53, 26);
    tm1637.point(1);       //включить точки
    tm1637.display(freq);  //вывести частоту
    tm1637.display(1, 15); //буква "F" (frequency)
  }
  if (enc1.isLeft()) {
    Potentiometr = Potentiometr - 2;          // если был поворот
    Potentiometr = constrain(Potentiometr, 0, 254);
    EEPROM.write(0, Potentiometr);
    freq = map(Potentiometr, 0, 254, 53, 26);
    tm1637.point(1);       //включить точки
    tm1637.display(freq);  //вывести частоту
    tm1637.display(1, 15); //буква "F" (frequency)
  }
  if (enc1.isPress()) {
    Potentiometr = 25;
    Potentiometr = constrain(Potentiometr, 0, 254);
    EEPROM.write(0, Potentiometr);        // если было нажатие
    freq = map(Potentiometr, 0, 254, 53, 26);
    tm1637.point(1);       //включить точки
    tm1637.display(freq);  //вывести частоту
    tm1637.display(1, 15); //буква "F" (frequency)
  }

  PotMapFreq = map(Potentiometr, 0, 254, 81, 178); //Конвертация диапазона для частоты от 50 Гц до 23 Гц
  constrain(PotMapFreq, 81, 178);
  PotMapSkvaz = map(Potentiometr, 0, 254, 30, 16); //Конвертация диапазона для скважности
  constrain(PotMapSkvaz, 30, 16);
  skvazh1 = 0;
  skvazh2 = 0;
  while (flag == 0) {         //Рачсет для пина 9 (первый полупериод)
    while (i < 100) {         //Читаем данные из массива с установленной задержкой PotMapFreq
      PWM_set(9, skvazh1);    // установить заполнение ШИМ на D9,согласно расчета от 0 до 2048
      PWM_set(10, skvazh2);   // установить заполнение ШИМ на D10, согласно расчета от 0 до 2048
      timeMillis = micros(); //таймер частоты (PotMapFreq(мкс) время действия одного значения из массива, или 1/200 периода(100 занчений * 2 полупериода))
      if (timeMillis - timePreview >= PotMapFreq) {
        timePreview = micros();
        skvazh1 = ((sinus[i] / 32) * PotMapSkvaz); //устанавливаем значение скважности согласно положению энкодера(30 - 94%, 16 - 50% для понижения напряжения пропорционально частоте )
        i = i + 1;
  enc1.tick();
  if (enc1.isRight()) {
    Potentiometr = Potentiometr + 2;         // если был поворот
    Potentiometr = constrain(Potentiometr, 0, 254);
    EEPROM.write(0, Potentiometr);
    freq = map(Potentiometr, 0, 254, 53, 26);
    tm1637.point(1);       //включить точки
    tm1637.display(freq);  //вывести частоту
    tm1637.display(1, 15); //буква "F" (frequency)
  }
  if (enc1.isLeft()) {
    Potentiometr = Potentiometr - 2;          // если был поворот
    Potentiometr = constrain(Potentiometr, 0, 254);
    EEPROM.write(0, Potentiometr);
    freq = map(Potentiometr, 0, 254, 53, 26);
    tm1637.point(1);       //включить точки
    tm1637.display(freq);  //вывести частоту
    tm1637.display(1, 15); //буква "F" (frequency)
  }
  if (enc1.isPress()) {
    Potentiometr = 25;
    Potentiometr = constrain(Potentiometr, 0, 254);
    EEPROM.write(0, Potentiometr);        // если было нажатие
    freq = map(Potentiometr, 0, 254, 53, 26);
    tm1637.point(1);       //включить точки
    tm1637.display(freq);  //вывести частоту
    tm1637.display(1, 15); //буква "F" (frequency)
  }
      } else {
        continue;
      }
    }
    flag = 1;
    i = 0;
  }
  skvazh1 = 0;
  skvazh2 = 0;
  while (flag == 1) {          //Все то же самое но для пина 10 (второй полупериод)
    while (i < 100) {          //Читаем данные из массива с установленной задержкой PotMapFreq
      PWM_set(9, skvazh1);     // установить заполнение ШИМ на D9,согласно расчета от 0 до 2048
      PWM_set(10, skvazh2);    // установить заполнение ШИМ на D10, согласно расчета от 0 до 2048
      timeMillis = micros();
      if (timeMillis - timePreview >= PotMapFreq) { //таймер частоты
        timePreview = micros();
        skvazh2 = ((sinus[i] / 32) * PotMapSkvaz); //устанавливаем значение скважности согласно положению энкодера
        i = i + 1;
  enc1.tick();
  if (enc1.isRight()) {
    Potentiometr = Potentiometr + 2;         // если был поворот
    Potentiometr = constrain(Potentiometr, 0, 254);
    EEPROM.write(0, Potentiometr);
    freq = map(Potentiometr, 0, 254, 53, 26);
    tm1637.point(1);       //включить точки
    tm1637.display(freq);  //вывести частоту
    tm1637.display(1, 15); //буква "F" (frequency)
  }
  if (enc1.isLeft()) {
    Potentiometr = Potentiometr - 2;          // если был поворот
    Potentiometr = constrain(Potentiometr, 0, 254);
    EEPROM.write(0, Potentiometr);
    freq = map(Potentiometr, 0, 254, 53, 26);
    tm1637.point(1);       //включить точки
    tm1637.display(freq);  //вывести частоту
    tm1637.display(1, 15); //буква "F" (frequency)
  }
  if (enc1.isPress()) {
    Potentiometr = 25;
    Potentiometr = constrain(Potentiometr, 0, 254);
    EEPROM.write(0, Potentiometr);        // если было нажатие
    freq = map(Potentiometr, 0, 254, 53, 26);
    tm1637.point(1);       //включить точки
    tm1637.display(freq);  //вывести частоту
    tm1637.display(1, 15); //буква "F" (frequency)
  }
      } else {
        continue;
      }
    }
    flag = 0;
    i = 0;
  }
}
